#include "../../include/types.h"
#include "../../include/pool.h"
#include "../../include/util.h"

#include <stdlib.h>
#include <string.h>

bool lm_pool_path_set_info(lm_pool_t *pool, char *info_path){
  free(pool->paths.info);
  pool->paths.info = NULL;

  if(NULL == info_path)
    return true;

  if(is_dir(info_path))
    return false;

  pool->paths.info = strdup(info_path);
  return true;
}

bool lm_pool_path_set_list(lm_pool_t *pool, char *list_path){
  free(pool->paths.list);
  pool->paths.list = NULL;

  if(NULL == list_path)
    return true;

  if(is_dir(list_path))
    return false;

  pool->paths.list = strdup(list_path);
  return true;
}

bool lm_pool_path_set_packages(lm_pool_t *pool, char *packages_path){
  free(pool->paths.packages);
  pool->paths.packages = NULL;

  if(NULL == packages_path)
    return true;

  if(is_file(packages_path))
    return false;

  pool->paths.packages = strdup(packages_path);
  return true;
}

bool lm_pool_path_is_empty(lm_pool_t *pool){
  return NULL == pool->paths.info ||
         NULL == pool->paths.list ||
         NULL == pool->paths.packages;
}

void lm_pool_path_free(lm_pool_t *pool){
  free(pool->paths.packages);
  free(pool->paths.info);
  free(pool->paths.list);
}
